﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using TestCS;

namespace TestCS
{
    /// <summary>
    /// 必须加这一行，内部使用
    /// </summary>
    [ToolboxItem(true)]

    public partial class YKApiT : UserControl
    {
        public int handle;
        public YKApiT()
        {
            InitializeComponent();
        }
        bool A = false;
        private void Connect_Click(object sender, EventArgs e)
        {
            if (A == false)
            {
                string ip = "127.0.0.1";
                char[] ip1 = ip.ToCharArray();
                handle = YKApi.Connect(ip1, 502);
                if (handle < 0)
                    Connect.Text = "连接失败";
                else
                    Connect.Text = "已成功连接，点击退出";

                A = true;
            }
            else
            {
                string ip = "127.0.0.1";
                char[] ip1 = ip.ToCharArray();
                handle = YKApi.Close(handle);
                handle = 0;
                Connect.Text = "已退出连接，点击连接";
                A = false;
            }

        }

#region 控件属性
        /// <summary>
        /// 增加控件属性，可在ProU上设置
        /// </summary>
        private Color backcolor1;
        [Category("外观"), DisplayName("背景色On"), Description("背景色变量为ON时的颜色")]
        public Color bk1
        {
            get { return backcolor1; }
            set { backcolor1 = value; }
        }

        private Color backcolor2;
        [Category("外观"), DisplayName("背景色OFF"), Description("背景色变量为OFF时的颜色")]
        public Color bk2
        {
            get { return backcolor2; }
            set { backcolor2 = value; }
        }

        /// <summary>
        /// 增加属性接口，把ProU的变量加载到控件中
        /// </summary>
        private String axis_addr = "";
        [Category("数据"), DisplayName("轴地址变量"), Description("轴地址")]
        public String lible1
        {
            get { return axis_addr; }
            set { axis_addr = value; }
        }

        private String axis_addr1 = "";
        [Category("数据"), DisplayName("轴地址变量"), Description("轴地址")]
        public String lible2
        {
            get { return axis_addr1; }
            set { axis_addr1 = value; }
        }
        #endregion


        #region ProCon测试

        void TestWrite()
        {
            
        }

        #endregion

        private void buttonaElem_R1_Click(object sender, EventArgs e)
        {
            UInt32 elem = (UInt32)comboBoxElem1.SelectedIndex;
            UInt32 index = (UInt32)numericUpDown_INDEX.Value;
            UInt32 trpe = (UInt32)comboBoxType.SelectedIndex;
            ushort[] Value = new ushort[2];
            uint num = 2;
            if (0 == trpe)
                num = 1;
            switch (elem)
            {
                case 0: ret = YKApi.ReadWordVD(handle, index, num, Value); break;
                case 1: ret = YKApi.ReadWordRD(handle, index, num, Value); break;
                case 2: ret = YKApi.ReadWordR(handle, index, num, Value); break;
                case 3: ret = YKApi.ReadWordD(handle, index, num, Value); break;
                case 4: ret = YKApi.ReadWordSD(handle, index, num, Value); break;
                case 5: ret = YKApi.ReadWordT(handle, index, num, Value); break;
                case 6: ret = YKApi.ReadWordC16(handle, index, num, Value); break;
                case 7: ret = YKApi.ReadWordC32(handle, index, num, Value); break;
                default: break;
            }

            if (ret != MyEnum.ERR_OK)
            {
                textEdit te = new textEdit();
                te.text = ret.ToString();
                te.Show();
            }

            switch (trpe)
            {
                case 0:
                    numericUpDown_Value1.Text = Value[0].ToString();
                    break;

                case 1:
                    int int32_d = 0;
                    YKApi.WordToIntT(Value, ref int32_d);
                    numericUpDown_Value1.Text = int32_d.ToString();
                    break;

                case 2:
                    float float_d = 0;
                    YKApi.WordToFloatT(Value, ref float_d);
                    numericUpDown_Value1.Text = float_d.ToString();
                    break;

                default: break;
            }
        }
        MyEnum ret;
        private void buttonaElem_W1_Click(object sender, EventArgs e)
        {
            UInt32 elem = (UInt32)comboBoxElem1.SelectedIndex;
            UInt32 index = (UInt32)numericUpDown_INDEX.Value;
            UInt32 trpe = (UInt32)comboBoxType.SelectedIndex;
            ushort[] Value = new ushort[2];
            double Value_F;
            uint num = 2; 
            double.TryParse(numericUpDown_Value1.Text, out Value_F);
            switch (trpe)
            {
                case 0:
                    Value[0] = (ushort)Value_F;
                    Value[1] = (ushort)0;
                    num = 1;
                    break;

                case 1:
                    YKApi.IntToWordT((int)Value_F, Value);
                    break;

                case 2:
                    YKApi.FloatToWordT((float)Value_F, Value);
                    break;

                default: break;

            }
            switch (elem)
            {
                case 0: ret = YKApi.WriteWordVD(handle, index, num, Value); break;
                case 1: ret = YKApi.WriteWordRD(handle, index, num, Value); break;
                case 2: ret = YKApi.WriteWordR(handle, index, num, Value); break;
                case 3: ret = YKApi.WriteWordD(handle, index, num, Value); break;
                case 4: ret = YKApi.WriteWordSD(handle, index, num, Value); break;
                case 5: ret = YKApi.WriteWordT(handle, index, num, Value); break;
                case 6: ret = YKApi.WriteWordC16(handle, index, num, Value); break;
                case 7: ret = YKApi.WriteWordC32(handle, index, num, Value); break;
                default: break;
            }

            if (ret != MyEnum.ERR_OK)
            {
                textEdit te = new textEdit();
                te.text = ret.ToString();
                te.Show();
            }

        }

        private void buttonaElem_R2_Click(object sender, EventArgs e)
        {
            UInt32 elem = (UInt32)comboBoxElem2.SelectedIndex;
            UInt32 index = (UInt32)numericUpDown_INDEX2.Value;
            ushort[] Value = new ushort[1];
            switch (elem)
            {
                case 0: ret = YKApi.ReadBitX(handle, index, 1, Value); break;
                case 1: Value[0] = 1; break;
                case 2: ret = YKApi.ReadBitM(handle, index, 1, Value); break;
                case 3: ret = YKApi.ReadBitSM(handle, index, 1, Value); break;
                case 4: ret = YKApi.ReadBitS(handle, index, 1, Value); break;
                case 5: ret = YKApi.ReadBitB(handle, index, 1, Value); break;
                case 6: ret = YKApi.ReadBitL(handle, index, 1, Value); break;
                case 7: ret = YKApi.ReadBitF(handle, index, 1, Value); break;
                default: break;
            }
            if (Value[0] == 0)
            {
                numericUpDown_Value2.Value = 0;
            }
            else
            {
                numericUpDown_Value2.Value = 1;
            }

            if (ret != MyEnum.ERR_OK)
            {
                textEdit te = new textEdit();
                te.text = ret.ToString();
                te.Show();
            }

        }

        private void buttonaElem_W2_Click(object sender, EventArgs e)
        {
            UInt32 elem = (UInt32)comboBoxElem2.SelectedIndex;
            UInt32 index = (UInt32)numericUpDown_INDEX2.Value;

            ushort[] Value = new ushort[1];
            Value[0] = (ushort)numericUpDown_Value2.Value;

            switch (elem)
            {
                case 0: break;
                case 1: ret = YKApi.WriteBitY(handle, index, 1, Value); break;
                case 2: ret = YKApi.WriteBitM(handle, index, 1, Value); break;
                case 3: ret = YKApi.WriteBitSM(handle, index, 1, Value); break;
                case 4: ret = YKApi.WriteBitS(handle, index, 1, Value); break;
                case 5: ret = YKApi.WriteBitB(handle, index, 1, Value); break;
                case 6: ret = YKApi.WriteBitL(handle, index, 1, Value); break;
                case 7: ret = YKApi.WriteBitF(handle, index, 1, Value); break;

                default: break;
            }

            if (ret != MyEnum.ERR_OK)
            {
                textEdit te = new textEdit();
                te.text = ret.ToString();
                te.Show();
            }

        }
    }
}
